//========================================================

class Mouse extends Controller {

//========================================================

    //----------------------------------------------------
    connect(){
    //----------------------------------------------------
document.addEventListener('', );
document.addEventListener('', );
document.addEventListener('', mouseWheel);

        document.addEventListener('mousedown', this.onMousePressed.bind(this));
        document.addEventListener('mouseup', this.onMouseReleased.bind(this));
        document.addEventListener('wheel', this.onWheel.bind(this));

    }

    //----------------------------------------------------
    disconnect(){
    //----------------------------------------------------

        return true;

    }
    //----------------------------------------------------
    onMousePressed(event){
    //----------------------------------------------------
        this.children.by_class(MouseButton).execute("onPressed",event);
    }

    //----------------------------------------------------
    onMouseReleased(event){
    //----------------------------------------------------
        this.children.by_class(MouseButton).execute("onRelease",event);
    }
    //----------------------------------------------------
    onWheel(event){
    //----------------------------------------------------
        this.children.by_class(MouseWheel).execute("onWheel",event);
    }
    //----------------------------------------------------
}
//========================================================

class MouseButton extends ControllerPart {

//========================================================

    //----------------------------------------------------
    onSetup(data){
    //----------------------------------------------------

        super.onSetup(data);
        this.add_variable("text",null);

    }
    //----------------------------------------------------
    onTest(event){
    //----------------------------------------------------

        if ( event.button == this.text){
            return true;
        }else{
            return false;
        }

    }
    //----------------------------------------------------
    onPressed(event){
    //----------------------------------------------------

          if ( this.onTest(event)==true){

            
            }

    }
    //----------------------------------------------------
    onRelease(event){
    //----------------------------------------------------

          if ( this.onTest(event)==true){

            
            }

    }
    //----------------------------------------------------
}
//========================================================

class MouseWheel extends ControllerPart {

//========================================================

    //----------------------------------------------------
    onSetup(data){
    //----------------------------------------------------

        super.onSetup(data);
        //this.add_variable("text",null);

    }

    //----------------------------------------------------
    onWheel(event){
    //----------------------------------------------------

         if(event.deltaY>0){

        }else{

        }

    }
    //----------------------------------------------------

}

//========================================================


